org.apache.lucene.classification

## Class KNearestNeighborClassifier

- java.lang.Object
- - org.apache.lucene.classification.KNearestNeighborClassifier

- All Implemented Interfaces:
    Classifier<BytesRef>

      public class KNearestNeighborClassifier
      extends Object
      implements Classifier<BytesRef>

  A k-Nearest Neighbor classifier (see `http://en.wikipedia.org/wiki/K-nearest_neighbors`) based on `MoreLikeThis`
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `KNearestNeighborClassifier(int k)` Create a `Classifier` using kNN algorithm
    `KNearestNeighborClassifier(int k, int minDocsFreq, int minTermFreq)` Create a `Classifier` using kNN algorithm

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `ClassificationResult<BytesRef>` | `assignClass(String text)` Assign a class (with score) to the given text String
    `List<ClassificationResult<BytesRef>>` | `getClasses(String text)` Get all the classes (sorted by score, descending) assigned to the given text String.
    `List<ClassificationResult<BytesRef>>` | `getClasses(String text, int max)` Get the first `max` classes (sorted by score, descending) assigned to the given text String.
    `void` | `train(LeafReader leafReader, String[] textFieldNames, String classFieldName, Analyzer analyzer, Query query)` Train the classifier using the underlying Lucene index
    `void` | `train(LeafReader leafReader, String textFieldName, String classFieldName, Analyzer analyzer)` Train the classifier using the underlying Lucene index
    `void` | `train(LeafReader leafReader, String textFieldName, String classFieldName, Analyzer analyzer, Query query)` Train the classifier using the underlying Lucene index

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### KNearestNeighborClassifier

          public KNearestNeighborClassifier(int k)

      Create a `Classifier` using kNN algorithm

    - #### KNearestNeighborClassifier

          public KNearestNeighborClassifier(int k,
                                    int minDocsFreq,
                                    int minTermFreq)

      Create a `Classifier` using kNN algorithm
      Parameters:
        `k` - the number of neighbors to analyze as an `int`
        `minDocsFreq` - the minimum number of docs frequency for MLT to be set with `MoreLikeThis.setMinDocFreq(int)`
        `minTermFreq` - the minimum number of term frequency for MLT to be set with `MoreLikeThis.setMinTermFreq(int)`

  - ### Method Detail

    - #### assignClass

          public ClassificationResult<BytesRef> assignClass(String text)
                                                     throws IOException

      Assign a class (with score) to the given text String
      Specified by:
        `assignClass` in interface `Classifier<BytesRef>`
      Parameters:
        `text` - a String containing text to be classified
      Returns:
        a `ClassificationResult` holding assigned class of type `T` and score
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getClasses

          public List<ClassificationResult<BytesRef>> getClasses(String text)
                                                          throws IOException

      Get all the classes (sorted by score, descending) assigned to the given text String.
      Specified by:
        `getClasses` in interface `Classifier<BytesRef>`
      Parameters:
        `text` - a String containing text to be classified
      Returns:
        the whole list of `ClassificationResult`, the classes and scores. Returns `null` if the classifier can't make lists.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getClasses

          public List<ClassificationResult<BytesRef>> getClasses(String text,
                                                        int max)
                                                          throws IOException

      Get the first `max` classes (sorted by score, descending) assigned to the given text String.
      Specified by:
        `getClasses` in interface `Classifier<BytesRef>`
      Parameters:
        `text` - a String containing text to be classified
        `max` - the number of return list elements
      Returns:
        the whole list of `ClassificationResult`, the classes and scores. Cut for "max" number of elements. Returns `null` if the classifier can't make lists.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### train

          public void train(LeafReader leafReader,
                   String textFieldName,
                   String classFieldName,
                   Analyzer analyzer)
                     throws IOException

      Train the classifier using the underlying Lucene index
      Specified by:
        `train` in interface `Classifier<BytesRef>`
      Parameters:
        `leafReader` - the reader to use to access the Lucene index
        `textFieldName` - the name of the field used to compare documents
        `classFieldName` - the name of the field containing the class assigned to documents
        `analyzer` - the analyzer used to tokenize / filter the unseen text
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### train

          public void train(LeafReader leafReader,
                   String textFieldName,
                   String classFieldName,
                   Analyzer analyzer,
                   Query query)
                     throws IOException

      Train the classifier using the underlying Lucene index
      Specified by:
        `train` in interface `Classifier<BytesRef>`
      Parameters:
        `leafReader` - the reader to use to access the Lucene index
        `textFieldName` - the name of the field used to compare documents
        `classFieldName` - the name of the field containing the class assigned to documents
        `analyzer` - the analyzer used to tokenize / filter the unseen text
        `query` - the query to filter which documents use for training
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### train

          public void train(LeafReader leafReader,
                   String[] textFieldNames,
                   String classFieldName,
                   Analyzer analyzer,
                   Query query)
                     throws IOException

      Train the classifier using the underlying Lucene index
      Specified by:
        `train` in interface `Classifier<BytesRef>`
      Parameters:
        `leafReader` - the reader to use to access the Lucene index
        `textFieldNames` - the names of the fields to be used to compare documents
        `classFieldName` - the name of the field containing the class assigned to documents
        `analyzer` - the analyzer used to tokenize / filter the unseen text
        `query` - the query to filter which documents use for training
      Throws:
        `IOException` - If there is a low-level I/O error.

Copyright © 2000-2017 Apache Software Foundation. All Rights Reserved.